## google-compute-image-packages 20190124

=== google_compute_engine_oslogin/Makefile ===
SHELL = /bin/sh

BASENAME = oslogin
NAME = google-compute-engine-$(BASENAME)
MAJOR = 1
MINOR = 4
REVISION = 3

LIBNSS_CACHE_OSLOGIN = libnss_cache_$(BASENAME)
LIBNSS_CACHE_OSLOGIN_NAME = libnss_cache_$(NAME)-$(MAJOR).$(MINOR).$(REVISION).so
LIBNSS_CACHE_OSLOGIN_SONAME = $(LIBNSS_CACHE_OSLOGIN).so.2
NSS_LIBRARY_NAME = libnss_$(NAME)-$(MAJOR).$(MINOR).$(REVISION).so
NSS_LIBRARY_SONAME = libnss_$(BASENAME).so.2
NSS_INSTALL_PATH = /lib
PAM_INSTALL_PATH = /lib/security
AUTHKEYS_INSTALL_PATH = /usr/bin

JSON_INCLUDE_PATH = /usr/include/json-c
INCLUDE_FLAGS = -I$(JSON_INCLUDE_PATH)

CXX ?= g++
CXXFLAGS += -fPIC# -Wall
CC ?= gcc
PAMFLAGS = $(LDFLAGS) $(INCLUDE_FLAGS) -shared
NSSFLAGS = $(LDFLAGS) $(INCLUDE_FLAGS) -shared -Wl,-soname,$(NSS_LIBRARY_SONAME)
LIBNSSFLAGS = $(LDFLAGS) -Wall -Wstrict-prototypes -fPIC -g
LIBNSS_SO_FLAGS = $(LIBNSSFLAGS) -shared -Wl,-soname,$(LIBNSS_CACHE_OSLOGIN_SONAME)

# UTILS
UTILS_DIR = utils
UTILS_SRC = $(UTILS_DIR)/$(BASENAME)_utils.cc
UTILS = $(UTILS_DIR)/$(BASENAME)_utils.o

# AUTHORIZED KEYS
AUTHKEYS_DIR = authorized_keys
AUTHKEYS_SRC = $(AUTHKEYS_DIR)/authorized_keys.cc
AUTHKEYS_BIN = google_authorized_keys

# NSS
NSS = nss_$(BASENAME)
NSS_DIR = nss_module
NSS_SRC = $(NSS_DIR)/$(NSS).cc

# NSS CACHE
NSS_CACHE = nss_cache
NSS_CACHE_DIR = nss_cache
NSS_CACHE_BIN = google_$(BASENAME)_nss_cache
NSS_CACHE_SRC = $(NSS_CACHE_DIR)/$(NSS_CACHE).cc

# LIBNSS OSLOGIN CACHE
LIBNSS_CACHE_OSLOGIN_DIR = $(LIBNSS_CACHE_OSLOGIN)
LIBNSS_CACHE = nss_cache_$(BASENAME)
LIBNSS_CACHE_SRC = $(LIBNSS_CACHE_OSLOGIN_DIR)/$(LIBNSS_CACHE).c
LIBNSS_CACHE_OBJ = $(LIBNSS_CACHE_OSLOGIN_DIR)/$(LIBNSS_CACHE).o
LIBNSS_COMPAT = compat/getpwent_r
LIBNSS_COMPAT_SRC = $(LIBNSS_CACHE_OSLOGIN_DIR)/$(LIBNSS_COMPAT).c
LIBNSS_COMPAT_OBJ = $(LIBNSS_CACHE_OSLOGIN_DIR)/$(LIBNSS_COMPAT).o

# PAM
PAM = pam_$(BASENAME)
PAM_DIR = pam_module
PAM_ADMIN = $(PAM)_admin
PAM_ADMIN_SRC = $(PAM_DIR)/$(PAM_ADMIN).cc
PAM_ADMIN_OBJ = $(PAM_DIR)/$(PAM_ADMIN).o
PAM_ADMIN_MOD = $(PAM_ADMIN).so
PAM_LOGIN = $(PAM)_login
PAM_LOGIN_SRC = $(PAM_DIR)/$(PAM_LOGIN).cc
PAM_LOGIN_OBJ = $(PAM_DIR)/$(PAM_LOGIN).o
PAM_LOGIN_MOD = $(PAM_LOGIN).so

# HELPER SCRIPTS
BIN_DIR = bin
OSLOGIN_HELPER = $(BIN_DIR)/google_oslogin_control
BIN_INSTALL_PATH = /usr/bin

# SELINUX POLICY
INSTALL_SELINUX =
POLICY_DIR = policy
SELINUX_INSTALL_NAME = oslogin.pp
SELINUX_MODULE = $(POLICY_DIR)/$(SELINUX_INSTALL_NAME)
SELINUX_INSTALL_PATH = /usr/share/selinux/packages

LIBS = -lcurl -ljson-c
PAM_LIBS = -lpam $(LIBS)

ifdef INSTALL_SELINUX
all: $(NSS) $(NSS_CACHE_BIN) $(LIBNSS_CACHE_OSLOGIN_NAME) $(PAM) $(AUTHKEYS_BIN)
else
all: $(NSS) $(NSS_CACHE_BIN) $(LIBNSS_CACHE_OSLOGIN_NAME) $(PAM) $(AUTHKEYS_BIN)
endif

$(NSS): $(NSS_LIBRARY_SOURCE) $(UTILS)
	$(CXX) $(CXXFLAGS) $(NSSFLAGS) -o $(NSS_LIBRARY_NAME) \
	$(NSS_SRC) $(UTILS) $(LIBS)

$(NSS_CACHE_BIN): $(NSS_CACHE_SRC) $(UTILS_SRC)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(INCLUDE_FLAGS) -o $(NSS_CACHE_BIN) $(NSS_CACHE_SRC) $(UTILS_SRC) $(LIBS)

$(LIBNSS_CACHE_OSLOGIN_NAME): $(LIBNSS_CACHE_OBJ) $(LIBNSS_COMPAT_OBJ)
	$(CXX) $(LIBNSS_SO_FLAGS) -o $(LIBNSS_CACHE_OSLOGIN_NAME) $(LIBNSS_CACHE_OBJ) $(LIBNSS_COMPAT_OBJ)

$(LIBNSS_CACHE_OBJ): $(LIBNSS_CACHE_SRC)
	$(CC) $(LIBNSSFLAGS) -c -o $(LIBNSS_CACHE_OBJ) $(LIBNSS_CACHE_SRC)

$(LIBNSS_COMPAT_OBJ): $(LIBNSS_COMPAT_SRC)
	$(CC) $(LIBNSSFLAGS) -c -o $(LIBNSS_COMPAT_OBJ) $(LIBNSS_COMPAT_SRC)

$(PAM): $(PAM_ADMIN_MOD) $(PAM_LOGIN_MOD)

$(PAM_LOGIN_MOD): $(PAM_LOGIN_OBJ) $(UTILS)
	$(CXX) $(PAMFLAGS) -o $(PAM_LOGIN_MOD) $(PAM_LOGIN_OBJ) $(UTILS) $(PAM_LIBS)

$(PAM_ADMIN_MOD): $(PAM_ADMIN_OBJ) $(UTILS)
	$(CXX) $(PAMFLAGS) -o $(PAM_ADMIN_MOD) $(PAM_ADMIN_OBJ) $(UTILS) $(PAM_LIBS)

$(PAM_LOGIN_OBJ): $(PAM_LOGIN_SRC)
	$(CXX) $(CXXFLAGS) -c $(PAM_LOGIN_SRC) -o $(PAM_LOGIN_OBJ)

$(PAM_ADMIN_OBJ): $(PAM_ADMIN_SRC)
	$(CXX) $(CXXFLAGS) -c $(PAM_ADMIN_SRC) -o $(PAM_ADMIN_OBJ)

$(AUTHKEYS_BIN): $(AUTHKEYS_SRC) $(UTILS_SRC)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(INCLUDE_FLAGS) -o $(AUTHKEYS_BIN) $(AUTHKEYS_SRC) $(UTILS_SRC) $(LIBS)

$(UTILS): $(UTILS_SRC)
	$(CXX) $(CXXFLAGS) $(INCLUDE_FLAGS) -c $(UTILS_SRC) -o $(UTILS)

install: $(NSS_LIBRARY_NAME) $(LIBNSS_OSLOGIN_CACHE_NAME) $(PAM_ADMIN_MOD) $(PAM_LOGIN_MOD) $(AUTHKEYS_BIN) $(NSS_CACHE_BIN)
	mkdir -p $(DESTDIR)$(PREFIX)/$(NSS_INSTALL_PATH)
	mkdir -p $(DESTDIR)$(PREFIX)/$(PAM_INSTALL_PATH)
	mkdir -p $(DESTDIR)$(PREFIX)/$(AUTHKEYS_INSTALL_PATH)
	mkdir -p $(DESTDIR)$(PREFIX)/$(BIN_INSTALL_PATH)
	install -m 0644 $(LIBNSS_CACHE_OSLOGIN_NAME) $(DESTDIR)$(PREFIX)/$(NSS_INSTALL_PATH)
	install -m 0644 $(NSS_LIBRARY_NAME) $(DESTDIR)$(PREFIX)/$(NSS_INSTALL_PATH)
	install -m 0644 $(PAM_ADMIN_MOD) $(PAM_LOGIN_MOD) $(DESTDIR)$(PREFIX)/$(PAM_INSTALL_PATH)
	install -m 0755 $(AUTHKEYS_BIN) $(DESTDIR)$(PREFIX)/$(AUTHKEYS_INSTALL_PATH)
	install -m 0755 $(OSLOGIN_HELPER) $(DESTDIR)$(PREFIX)/$(BIN_INSTALL_PATH)
	install -m 0755 $(NSS_CACHE_BIN) $(DESTDIR)$(PREFIX)/$(BIN_INSTALL_PATH)
ifdef INSTALL_SELINUX
	mkdir -p $(DESTDIR)$(PREFIX)/$(SELINUX_INSTALL_PATH)
	install -T -m 0644 $(SELINUX_MODULE) $(DESTDIR)$(PREFIX)/$(SELINUX_INSTALL_PATH)/$(SELINUX_INSTALL_NAME)
endif

uninstall:
	rm -f $(DESTDIR)$(PREFIX)/$(NSS_INSTALL_PATH)/$(LIBNSS_CACHE_OSLOGIN_NAME)
	rm -f $(DESTDIR)$(PREFIX)/$(NSS_INSTALL_PATH)/$(NSS_LIBRARY_NAME)
	rm -f $(DESTDIR)$(PREFIX)/$(PAM_INSTALL_PATH)/$(PAM_ADMIN_MOD)
	rm -f $(DESTDIR)$(PREFIX)/$(PAM_INSTALL_PATH)/$(PAM_LOGIN_MOD)
	rm -f $(DESTDIR)$(PREFIX)/$(AUTHKEYS_INSTALL_PATH)/$(AUTHKEYS_BIN)
	rm -f $(DESTDIR)$(PREFIX)/$(BIN_INSTALL_PATH)/$(OSLOGIN_HELPER)
	rm -f $(DESTDIR)$(PREFIX)/$(BIN_INSTALL_PATH)/$(NSS_CACHE_BIN)
clean:
	rm -f $(UTILS) $(NSS_LIBRARY_NAME) $(LIBNSS_CACHE_OSLOGIN_NAME) $(LIBNSS_CACHE_OBJ) $(LIBNSS_COMPAT_OBJ) $(PAM_ADMIN_OBJ) $(PAM_ADMIN_MOD) $(PAM_LOGIN_OBJ) $(PAM_LOGIN_MOD) $(AUTHKEYS_BIN) $(NSS_CACHE_BIN)

## google-compute-image-packages 20181206

=== debian/changelog ===
google-compute-image-packages (20181206-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Lucas Kanashiro <lucas.kanashiro@collabora.com>  Wed, 16 Jan 2019 14:13:34 -0200

google-compute-image-packages (20181206-2) unstable; urgency=medium

  * Add a patch fixing a python 3 issue when it tries to write to file

 -- Lucas Kanashiro <lucas.kanashiro@collabora.com>  Thu, 03 Jan 2019 11:14:31 -0200

google-compute-image-packages (20181206-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Bastian Blank <waldi@debian.org>  Wed, 16 Jan 2019 15:12:15 +0100

google-compute-image-packages (20181206-1) unstable; urgency=medium

  * New upstream version 20181206
  * Remove patches already applied by upstream
  * Declare compliance with Debian Policy 4.3.0
  * Remove unused entries in debian/copyright

 -- Lucas Kanashiro <lucas.kanashiro@collabora.com>  Wed, 26 Dec 2018 12:07:01 -0200

google-compute-image-packages (20180905-2) unstable; urgency=medium

  * Add patch enabling jounald to forward logs to console
  * Install journald conf instead of rsyslog
  * Remove runtime dependency on rsyslog
  * Do not install apt.conf files
  * Do not install modprobe config file
  * Remove irqbalance conflict for now
  * Add patch removing WantedBy=sshd from instance-setup init script

 -- Lucas Kanashiro <lucas.kanashiro@collabora.com>  Thu, 20 Dec 2018 10:04:21 -0200

google-compute-image-packages (20180905-1) unstable; urgency=medium

  * Initial release (Closes: #908077)

 -- Lucas Kanashiro <lucas.kanashiro@collabora.com>  Mon, 15 Oct 2018 16:18:23 -0300

=== debian/control ===
Source: google-compute-image-packages
Section: admin
Priority: optional
Maintainer: Debian Cloud Team <debian-cloud@lists.debian.org>
Uploaders: Lucas Kanashiro <lucas.kanashiro@collabora.com>
Build-Depends: debhelper (>= 11),
               dh-python,
               libcurl4-openssl-dev,
               libjson-c-dev,
               libpam0g-dev,
               python3-all,
               python3-boto,
               python3-distro,
               python3-pytest,
               python3-setuptools
Standards-Version: 4.3.0
Testsuite: autopkgtest-pkg-python
Vcs-Git: https://salsa.debian.org/debian/google-compute-image-packages.git
Vcs-Browser: https://salsa.debian.org/debian/google-compute-image-packages
Homepage: https://github.com/GoogleCloudPlatform/compute-image-packages

Package: google-compute-engine
Architecture: all
Depends: google-compute-engine-oslogin,
         python3-google-compute-engine (= ${source:Version}),
         ${misc:Depends}
Description: Google Compute Engine guest environment for cloud images
 This package contains a set of scripts, configuration, and systemd init files
 for features specific to the Google Compute Engine cloud environment. These
 features are Google Compute Engine specific and need to be configured by
 special daemons provided by this package. Some examples of these services are:
 configure specific network settings, run startup/shutdown scripts and store
 user provided ssh keys for machine access.

Package: python3-google-compute-engine
Section: python
Architecture: all
Depends: ${misc:Depends},
         ${python3:Depends}
Description: Python library for Google Compute Engine interaction (Python 3)
 Python 3.x library used to setup and manage resources in Google Compute Engine
 guests machines in a cloud environment such as accounts, clock skew, disk
 expand, instance setup, network and metadata scripts.

Package: google-compute-engine-oslogin
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: OS Login guest environment for Google Compute Engine
 Contains applications and configurations for using OS Login on Google Compute
 Engine Virtual Machine Instances.
 .
 It is composed by:
  * Authorized Keys Command to fetch SSH keys from the user's OS Login profile
    and make them available to sshd.
  * NSS Module to provide support for making OS Login user and group
    information available to the system, using NSS (Name Service Switch)
    functionality.
  * PAM Module to provide authorization and authentication support allowing
    the system to use data stored in Google Cloud IAM permissions to control
    both, the ability to log into an instance, and to perform operations as
    root (sudo).

## google-compute-image-packages 20190124

=== debian/changelog ===
google-compute-image-packages (20190124-3) unstable; urgency=medium

  * Apply patch to write daemons output to journal and console
  * Do not install journald config to forward all logs to the
    console (Closes: #923889)

 -- Lucas Kanashiro <lucas.kanashiro@collabora.com>  Thu, 14 Mar 2019 16:05:48 -0300

google-compute-image-packages (20190124-2) unstable; urgency=medium

  * Disable patches that are leading to breakages in GCE
  * Install the journald config file to redirect logs to console

 -- Lucas Kanashiro <lucas.kanashiro@collabora.com>  Wed, 06 Mar 2019 14:49:53 -0300

google-compute-image-packages (20190124-1) unstable; urgency=medium

  * New upstream version 20190124
  * Refresh patch
  * Bump debhelper compatibility level to 12

 -- Lucas Kanashiro <lucas.kanashiro@collabora.com>  Tue, 12 Feb 2019 10:53:08 -0200

google-compute-image-packages (20181206-4) unstable; urgency=medium

  * Only write daemon output to console.
  * Remove dependency clutter from systemd services.

 -- Bastian Blank <waldi@debian.org>  Fri, 08 Feb 2019 10:41:22 +0100

google-compute-image-packages (20181206-3) unstable; urgency=medium

  [ Bastian Blank ]
  * Set maintainer to Debian Cloud Team.

  [ Lucas Kanashiro ]
  * Add patch disabling boto by default

 -- Lucas Kanashiro <lucas.kanashiro@collabora.com>  Tue, 22 Jan 2019 15:52:09 -0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian Cloud Team <debian-cloud@lists.debian.org>
 Uploaders: Lucas Kanashiro <lucas.kanashiro@collabora.com>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper (>= 12),
                dh-python,
                libcurl4-openssl-dev,
                libjson-c-dev,

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=google-compute-engine
export PYBUILD_TEST_PYTEST=1
export PYBUILD_TEST_ARGS={dir}/google_compute_engine/
export PYBUILD_SYSTEM=distutils

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

OSLOGIN_DIR=google_compute_engine_oslogin

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_build:
	dh_auto_build
	$(MAKE) -C $(OSLOGIN_DIR) all

override_dh_auto_install:
	dh_auto_install
	
	$(MAKE) -C $(OSLOGIN_DIR) \
		DESTDIR=$(CURDIR)/debian/tmp \
		NSS_INSTALL_PATH=/lib/$(DEB_HOST_MULTIARCH) \
		PAM_INSTALL_PATH=/lib/$(DEB_HOST_MULTIARCH)/security \
		BIN_INSTALL_PATH=/usr/bin install
	
	cd $(CURDIR)/debian/tmp/lib/$(DEB_HOST_MULTIARCH) && \
               ln -s libnss_cache_google-compute-engine-oslogin-*.so libnss_cache_oslogin.so.2 && \
               ln -s libnss_google-compute-engine-oslogin-*.so libnss_oslogin.so.2

override_dh_clean:
	dh_clean
	rm -rf google_compute_engine.egg-info

## google-compute-image-packages 20190916

=== debian/changelog ===
google-compute-image-packages (20190916-1) unstable; urgency=medium

  * New upstream version 20190916
  * Fix d/rules build paths
  * Refresh patches
  * Fix d/google-compute-engine.install paths
  * update d/watch to start with letter v
  * Update d/control Uploaders list
  * Update d/control to Standards-Version: 4.4.0
  * Fix d/copyright file paths
  * Fix d/google-compute-engine.install udev install path

 -- Helen Koike <helen.koike@collabora.com>  Tue, 01 Oct 2019 17:06:39 -0300

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,9 @@
 Section: admin
 Priority: optional
 Maintainer: Debian Cloud Team <debian-cloud@lists.debian.org>
-Uploaders: Lucas Kanashiro <lucas.kanashiro@collabora.com>
+Uploaders:
+ Lucas Kanashiro <kanashiro@debian.org>,
+ Helen Koike <helen.koike@collabora.com>
 Build-Depends: debhelper (>= 12),
                dh-python,
                libcurl4-openssl-dev,
@@ -13,7 +15,7 @@
                python3-distro,
                python3-pytest,
                python3-setuptools
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Testsuite: autopkgtest-pkg-python
 Vcs-Git: https://salsa.debian.org/debian/google-compute-image-packages.git
 Vcs-Browser: https://salsa.debian.org/debian/google-compute-image-packages

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=google-compute-engine
export PYBUILD_TEST_PYTEST=1
export PYBUILD_TEST_ARGS={dir}/google_compute_engine/
export PYBUILD_SYSTEM=distutils
export PYBUILD_DIR=packages/python-google-compute-engine/

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

OSLOGIN_DIR=packages/google-compute-engine-oslogin

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_build:
	dh_auto_build
	$(MAKE) -C $(OSLOGIN_DIR) all

override_dh_auto_install:
	dh_auto_install
	
	$(MAKE) -C $(OSLOGIN_DIR) \
		DESTDIR=$(CURDIR)/debian/tmp \
		LIBDIR=/lib/$(DEB_HOST_MULTIARCH) install

override_dh_clean:
	dh_clean
	rm -rf google_compute_engine.egg-info

=== debian/watch ===
version=3
https://github.com/GoogleCloudPlatform/compute-image-packages/releases \/.*\/v?([\d\.]*)\.tar\.gz
